function [Ps,Qs,Pr,Qr,varargout] = flows_phs(a,Ps,Qs,Pr,Qr,varargin)

global DAE

if nargin == 7
  varargout{1} = [varargin{1}; a.bus1];
  varargout{2} = [varargin{2}; a.bus2];
end

if ~a.n, return, end

Vf = a.u.*DAE.y(a.v1).*exp(i*DAE.y(a.bus1));
Vt = a.u.*DAE.y(a.v2).*exp(i*DAE.y(a.bus2));  
y = admittance_phs(a);
m = a.con(:,15).*exp(i*DAE.x(a.alpha));

Ss = Vf.*conj((Vf-Vt.*m).*y);
Sr = Vt.*conj((Vt.*m-Vf).*y.*conj(m));

Ps = [Ps; real(Ss)];
Qs = [Qs; imag(Ss)];
Pr = [Pr; real(Sr)];
Qr = [Qr; imag(Sr)];
