function bdmatrix_sssc(a)

global LA DAE 

LA.b_sssc = [];  
LA.d_sssc = [];  

if ~a.n
  fm_disp('* * * No SSSC device found')
  return
end

iv = find(a.con(:,2) == 1);  % index - operation mode V constant
ip = find(a.con(:,2) == 3);  % index - operation mode P constant

Fu = sparse(DAE.n,a.n);
Gu = sparse(a.v0(iv),iv,a.u(iv),DAE.m,a.n) + ...
     sparse(a.pref(ip),ip,a.u(ip),DAE.m,a.n);

% B & D matrix for SSSC references
LA.d_sssc = -full(DAE.Gy\Gu);
LA.b_sssc = full(Fu + DAE.Fy*LA.d_sssc);  

